#include <ESP8266WiFi.h>//библиотека для использования wi-fi
#include <Servo.h>//библиотека для использования сервопривода
Servo myservo1;//создание подкласса myservo1 класс Servo
const char* ssid = "P60";//инициализация ssid нашей локальной сети 
const char* password = "12345678";//инициализация пароля нашей локальной сети
#define B 3950 // B-коэффициент
#define SERIAL_R 102000 // сопротивление последовательного резистора, 102 кОм
#define THERMISTOR_R 100000 // номинальное сопротивления термистора, 100 кОм
#define NOMINAL_T 25 // номинальная температура (при которой TR = 100 кОм)

const byte tempPin = A0;//  заменяем А0 на termPin
float tr;// переменная tr необходимая нам в будущем

WiFiServer server(80);// Номер порта для сервера


String header;// HTTP-запрос

// текущее состояние кнопки
String output26State = "off";
String output27State = "off";

// Номера выводов
const int output26 = 12;//светодиод
const int output27 = A0;//серводвигатель
//пременные необходимые в будущем
float steinhart;
int val;

void setup() {
  Serial.begin(115200);// включаем передачу данных
  // Настраиваем выводы платы
  pinMode(output26, OUTPUT);
  pinMode(output27, OUTPUT);
  pinMode( tempPin, INPUT );
  myservo1.attach(4);
  myservo1.write(180);
  // Переводим выводы в LOW
  digitalWrite(output26, LOW);
  analogWrite(output27, 0);

  // Подключаемся к Wi-Fi
  Serial.print("Connecting to ");//выводим в терминал сообщение
  Serial.println(ssid);//выводим в терминал сообщение
  WiFi.begin(ssid, password);//подключаемся к локальной сети
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }// пока не подключимся к локальной сети кождые пол-секунды выводим "."
  // Выводим локальный IP-адрес и запускаем сервер
  Serial.println("");
  Serial.println("WiFi connected.");// сообщение о успешным подключении к локальной сети
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());// IP адресс локальной сети
  server.begin();// запускаем сервер
}

void loop() {
  
  WiFiClient client = server.available(); // прослушка входящих клиентов
  if (client) { // Если подключается новый клиент,
    Serial.println("New Client."); // выводим сообщение
    String currentLine = "";
    while (client.connected()) { // цикл, пока есть соединение клиента
      if (client.available()) { // если от клиента поступают данные,
        char c = client.read(); // читаем байт, затем
        Serial.write(c); // выводим на экран
        header += c;
        if (c == '\n') { // если байт является переводом строки
          // если пустая строка, мы получили два символа перевода строки
          // значит это конец HTTP-запроса, формируем ответ сервера:
          if (currentLine.length() == 0) {
            // HTTP заголовки начинаются с кода ответа (напр., HTTP / 1.1 200 OK)
            // и content-type, затем пустая строка:
            client.println("HTTP/1.1 200 OK");
            client.println("Content-type:text/html");
            client.println("Connection: close");
            client.println();

            // Включаем или выключаем светодиоды
            if (header.indexOf("GET /26/on") >= 0) {
              Serial.println("GPIO 26 on");
              output26State = "включен";
              digitalWrite(output26, HIGH);
            } else if (header.indexOf("GET /26/off") >= 0) {
              Serial.println("GPIO 26 off");
              output26State = "выключен";
              digitalWrite(output26, LOW);
            } else if (header.indexOf("GET /27/on") >= 0) {
              Serial.println("GPIO 27 on");
              output27State = "открыта";
              myservo1.write(0);
            } else if (header.indexOf("GET /27/off") >= 0) {
              Serial.println("GPIO 27 off");
              output27State = "закрыта";
              myservo1.write(180);
            }
            // Формируем веб-страницу на сервере
            client.println("<!DOCTYPE html><html>");
            client.println("<head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1\", charset=\"UTF-8\">");
            client.println("<link rel=\"icon\" href=\"data:,\">");
            // CSS для кнопок
            client.println("<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}");
            client.println(".button { background-color: #4CAF50; border:  none; color: white; padding: 16px 40px;");
            client.println("text-decoration: none; font-size: 30px; margin: 2px; cursor: pointer;}");
            client.println(".button2 {background-color:#555555;}</style></head>");
            client.println("<body><h1><b>Умный дом.</b></h1>");
            client.println("<body><h1>Панель управлнеия.</h1>");
            // Выводим текущее состояние кнопок
            client.println("<p>Свет " + output26State + "</p>");
            // Если output26State сейчас выкл, то выводим надпись вкл
            if (output26State == "выключен") {
              client.println("<p><a href=\"/26/on\"><button class=\"button\">ВКЛ</button></a></p>");
            } else {
              client.println("<p><a href=\"/26/off\"><button class=\"button button2\">ВЫКЛ</button></a></p>");
            }
            // Аналогично для второй кнопки
            client.println("<p>Форточка " + output27State + "</p>");
            if (output27State == "закрыта") {
              client.println("<p><a href=\"/27/on\"><button class=\"button\">ОТКРЫТЬ</button></a></p>");
            } else {
              client.println("<p><a href=\"/27/off\"><button class=\"button button2\">ЗАКРЫТЬ</button></a></p>");
            }
            int t = analogRead( tempPin );
            float tr = 1023.0 / t - 1;
            tr = SERIAL_R / tr;
            Serial.print("R=");
            Serial.print(tr);
            Serial.print(", t=");// строки 123-128 считываем информацию с терморезистора

            
            steinhart = tr / THERMISTOR_R; // (R/Ro)
            steinhart = log(steinhart); // ln(R/Ro)
            steinhart /= B; // 1/B * ln(R/Ro)
            steinhart += 1.0 / (NOMINAL_T + 273.15); // + (1/To)
            steinhart = 1.0 / steinhart; // Invert
            steinhart -= 251.15; //строки 131-136 перещёт сопративления в градусы цельсия
            Serial.println(steinhart);
            client.println("<p>Температура:  " + (String)steinhart + "</p>");
            client.println("</body></html>");
            // HTTP-ответ завершается пустой строкой
            client.println();
            break;
          } else { // если получили новую строку, очищаем currentLine
            currentLine = "";
          }
        } else if (c != '\r') { // Если получили что-то ещё кроме возврата строки,
          currentLine += c; // добавляем в конец currentLine
        }
      }
    }
    // Очистим переменную
    header = "";
    // Закрываем соединение
    client.stop();
    Serial.println("Client disconnected.");
    Serial.println("");
  }
}